/*
 * File:   serial.c
 * Author: riddle
 *
 * Created on July 9, 2024, 3:00 PM
 */


#include <stdbool.h>
#include <xc.h>

bool EUSART1_IsRxReady(void)
{
    return (bool)(PIR1bits.RC1IF);
}

bool EUSART1_IsTxReady(void)
{
    return (bool)(PIR1bits.TX1IF && TXSTA1bits.TXEN);
}
void EUSART1_Write(uint8_t txData)
{
    TXREG1 = txData;
}
void sputch(char txData)
{
    while(!(EUSART1_IsTxReady()))
    {
    }
    return EUSART1_Write(txData);   
}

void sputs(char* strData) {
    int i=0;
    while(strData[i]!=0)
       sputch(strData[i++]);
    sputch('\n');
}

uint8_t EUSART1_Read(void)
{
    return RCREG1;
}
uint8_t sgetch(void)
{
    while(!(EUSART1_IsRxReady()))
    {
    }
    return EUSART1_Read();
}

void Init_Serial(uint8_t use232adapter) {
        //manually configure serial for high-speed inverted polarity - no MAX232 needed, 115200 bps
    SPBRGH1=0;                       
    TXSTA1bits.BRGH=1;                          //BRGH - high speed BRG
    BAUDCON1bits.BRG16=1;                         //BRG16 - 8-bit BRG
    SPBRG1=138;                      //64MHz/(4*(138+1))=115108

//    TRISC=0b11000000;                 //port C all out - RX1 and TX1 in

    TXSTA1bits.SYNC=0;                          //SYNC off for async serial
    RCSTA1bits.SPEN=1;                          //SPEN enables serial port

    if(use232adapter==1)
        BAUDCON1bits.CKTXP=1;                     //CKTXP invert polarity so no converter needed
    TXSTA1bits.TXEN=1;                          //TXEN to enable transmit
    if(use232adapter==1)
        BAUDCON1bits.DTRXP=1;                     //DTRXP invert polarity so no converter needed
    RCSTA1bits.CREN=1;                          //CREN to enable receive

}